onStart {
  # Find connected slider
  @slide_parent = nil
  @slider = nil
  @joint_name = nil
  parent_joints = this.group.get_attribute("SPOBJ", "parentJoints").to_a
  parent_joints.each { |jname|
    if jname =~ /slider|piston|spring|corkscrew/i
      @joint_name = jname
      break
    end
  }
  next unless @joint_name
  # Find slider associated with joint name
  Sketchup.active_model.entities.each { |e|
    next unless e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance)
    if e.get_attribute('SPJOINT', 'name', '') == @joint_name
      @slider = e
    else
      found = false
      e.entities.each { |ec|
        if ec.is_a?(Sketchup::Group) && ec.get_attribute('SPJOINT', 'name', '') == @joint_name
          @slider_parent = e
          @slider = ec
          found = true
          break
        end
      }
      break if found
    end
  }
  next unless @slider
  # Get min/max data associated with a slider
  slider_min = @slider.get_attribute('SPJOINT', 'min', 0)
  slider_max = @slider.get_attribute('SPJOINT', 'max', 0)
  @slider_range = (slider_max - slider_min).to_f
}

onUpdate {
  if @slider
    # Calculate object position and ratio on slider.
    pt = this.group.transformation.origin
    if @slider_parent
      tra = @slider_parent.transformation * @slider.transformation
    else
      tra = @slider.transformation
    end
    pt.transform!(tra.inverse)
    pos = pt.z
    ratio = @slider_range.zero? ? 0 : pos / @slider_range
    ratio = ratio - 0.06
    ratio = 1.00 if ratio > 1.00
    ratio = 0.00 if ratio < 0.00
    $sliderg = "%03d" % (ratio * 100).round
  end
}

onEnd {
}