# DomoticX Virtual 3D Device Port SU15 interface.
 
# Wat moet er gebeuren bij het starten van de simulatie?
onstart{
  $fill = 1
  compoortopties = ["Seriele poort:", "Baudrate:"]
  # Standaard waarden!, deze kun je zelf aanpassen!
  standaard = ["COM8", "9600"]
  # Lijst met baudrates voor de dropdownlijst in het menu.
  baudratelijst = ["", "4800|9600|14400|19200|28800|38400|57600|115200"]
  # Geef het dialoogvenster weer voor vraag naar gegevens.
  serialsettings = UI.inputbox(compoortopties, standaard, baudratelijst, "Seriele poort instellingen:")
 
  if serialsettings != FALSE
    # Haal de instellingen uit het diagloogvenster en koppel deze aan een variabele.
    $comport = serialsettings[0]
    $baudrate = serialsettings[1].to_i
 
    begin
      # Open de seriele poort.
      @serial = Serial.new($comport, $baudrate)
    rescue RubySerial::Exception => e
      # Sluit de seriele poort als deze open staat.
      @serial.close if @serial
      # Reset/stop de simulatie.
      MSketchyPhysics3::SketchyPhysicsClient.physicsReset
      # Geef een bericht dat de seriele poort niet is gevonden.
      UI.messagebox("Seriele poort niet gevonden!")
    end
  else
    # Reset/stop de simulatie.
    MSketchyPhysics3::SketchyPhysicsClient.physicsReset
  end
}

onUpdate {
# Sluit het 'control panel' venster bij het starten van de simulatie.
MSketchyPhysics3.closeControlPanel if frame == 1

# Geef de gegevens weer aan de linker zijde (log).
logLine("COM poort: " + $comport.to_s)
logLine("BAUD rate: " + $baudrate.to_s)
logLine("")
logLine("Waarde rood: " + $sliderr.to_s)
logLine("Waarde groen: " + $sliderg.to_s)
logLine("Waarde blauw: " + $sliderb.to_s)
logLine("")
logLine("Seriele data: " + $sliderr.to_s + $sliderg.to_s + $sliderb.to_s)
logLine("")
logLine("")
# Schrijf de data weg naar de seriele poort (incl. newline)
@serial.write($sliderr.to_s + $sliderg.to_s + $sliderb.to_s + "\n")
}

# Wat moet er gebeuren als de de simulatie stopt?
onend{
  # Sluit de seriele poort als deze open staat.
  @serial.close if @serial
}